// app.c

#include <windows.h>
#include <stdio.h>
#include "wdj.h"

//-----------------------------------------------------------------
VOID __cdecl main(void)
{
    HANDLE hDevice0, hDevice1, hDeviceX;

    //
    // Open a handle to the normal device object by symbolic
    // link name (Win32 name space).
    //

    hDevice0 = CreateFile("\\\\.\\UserWdj0", GENERIC_READ | 
                          GENERIC_WRITE,0,NULL,OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,NULL);

    if (hDevice0 == INVALID_HANDLE_VALUE) {
        printf("Error opening device 0 (%d)\n", GetLastError());
     } else {
        printf("Successfully opened device 0\n");
        CloseHandle(hDevice0);
    }

    //
    // Attempt to open a handle to the second device object.
    //

    hDevice1 = CreateFile("\\\\.\\UserWdj1", GENERIC_READ,0,NULL,
                          OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
                          NULL);

    if (hDevice1 == INVALID_HANDLE_VALUE) {
        printf("No Symbolic link, as expected, %d\n",
                GetLastError());
        
        //
        // Define a name for the exclusive device object.
        //

        if (DefineDosDevice(DDD_RAW_TARGET_PATH, "UserWdj1",
                            "\\Device\\Wdj1")) {
        
            hDevice1 = CreateFile("\\\\.\\UserWdj1",GENERIC_READ,
                                  0,NULL,OPEN_EXISTING,
                                  FILE_ATTRIBUTE_NORMAL,NULL);

            if (hDevice1 == INVALID_HANDLE_VALUE) {
                printf("Error opening device 1 (%d)\n",
                        GetLastError());
            }

            //
            // Exclusive device object, a second open should fail
            //

            hDeviceX = CreateFile("\\\\.\\UserWdj1",GENERIC_READ,
                                  0,NULL,OPEN_EXISTING,
                                  FILE_ATTRIBUTE_NORMAL,NULL);

            if (hDeviceX == INVALID_HANDLE_VALUE) {
                printf("Expected error opening device 1 (%d)\n", 
                       GetLastError());
            }
            
            CloseHandle(hDevice1);
        }
    }
}

